=== vendor/github.com/matttproud/golang_protobuf_extensions/pbutil/Makefile ===
all:

cover:
	go test -cover -v -coverprofile=cover.dat ./...
	go tool cover -func cover.dat

.PHONY: cover
