=== debian/changelog ===
containerd-app (2.0.0~rc3-0ubuntu1) oracular; urgency=medium

  * No-change rebuild to fix incorrect package version. (LP: #2089704)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 28 Nov 2024 15:40:04 -0300
