## containerd-app 2.0.0

=== debian/changelog ===
containerd-app (2.0.0-0ubuntu1) plucky; urgency=medium

  * New upstream version 2.0.0. (LP: #2089704)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 26 Nov 2024 21:03:03 -0300
