=== debian/rules ===
--- 
+++ 
@@ -14,17 +14,17 @@
 # https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
 export GO111MODULE := auto
 
-# Build with Golang 1.23
-export PATH := /usr/lib/go-1.23/bin:$(PATH)
+# Build with Golang 1.22
+export PATH := /usr/lib/go-1.22/bin:$(PATH)
 
 execute_before_dh_gencontrol:
 	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
 	DH_GOLANG_BUILDPKG=' \
 		-tags "$(TAGS)" \
-		github.com/containerd/containerd/cmd/containerd \
-		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
-		github.com/containerd/containerd/cmd/containerd-stress \
-		github.com/containerd/containerd/cmd/ctr \
+		github.com/containerd/containerd/v2/cmd/containerd \
+		github.com/containerd/containerd/v2/cmd/containerd-shim-runc-v2 \
+		github.com/containerd/containerd/v2/cmd/containerd-stress \
+		github.com/containerd/containerd/v2/cmd/ctr \
 	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
 
 override_dh_auto_configure:
@@ -59,9 +59,9 @@
 
 execute_after_dh_installsystemd:
 	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
-	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
-		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
-		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service
+	grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/containerd/usr/lib/systemd/system/containerd.service \
+		&& ! grep '/usr/local/bin/containerd' debian/containerd/usr/lib/systemd/system/containerd.service
 
 override_dh_dwz:
 	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
